/////////////////////
//www.hellofpga.com//
/////////////////////
`timescale 1ns / 1ps
module KEY_TEST(
    input clk,
    output LED,
    input KEY
);

reg [1:0]debounce_mode=2'd0;
reg [21:0]debounce_count=22'd0;

reg [1:0]KEY_r=0;
always@(posedge clk)begin
    KEY_r[1]<= KEY_r[0];
    KEY_r[0]<= KEY;
end
wire KEY_POSEDGE=(~KEY_r[1]&KEY_r[0])?1'b1:1'b0;


reg KEY_value=0;
always@(posedge clk)begin
    if(debounce_mode==0)begin
        debounce_count<=22'd0;
        debounce_mode<=2'd1;
        KEY_value<=0;
    end
    else if(debounce_mode==1)begin
        if(KEY_POSEDGE==1)begin
            debounce_count<=22'd0;
            debounce_mode<=2'd2;
        end
    end
    else if(debounce_mode==2)begin
        if(debounce_count>=22'd2_500_000)debounce_mode<=2'd3;
        else begin
            if(KEY==0)debounce_mode<=2'd0;
            debounce_count<=debounce_count+1'b1;
        end 
    end
    else begin
        if(KEY==0)debounce_mode<=2'd0;
        KEY_value<=1'b1;
    end
end

assign LED=KEY_value;

endmodule